import es, popuplib, random, gamethread, math
from dnds import *
info = es.AddonInfo()
info.name = 'D&DSource Mod - CSTRIKE'
info.version = '0.0.2 Python'
info.url = 'http://addons.eventscripts.com/addons/view/dnds'
info.basename = 'cstrikednds'
info.author = 'J3ff Hoogland'
#Begin Events
#Local Events
def item_pickup(ev):
    userid = int(ev['userid'])
    if ev['item'] in Weapons:
        Classes = dnds.getPlayer(userid)['Character'].key['classes'].keys()
        wplist = []
        for c in Classes:
            wplist += dnds.Classes[c]['weapons']
        if ev['item'] not in wplist:
            es.server.queuecmd('est_dropweapon %s weapon_%s'%(userid, ev['item']))
def player_spawn(ev):
    userid = int(ev['userid'])
    Character = dnds.getPlayer(userid)['Character']
    Playerlib = dnds.getPlayer(userid)['playerlib']
    Player = dnds.getPlayer(userid)['Player']
    for x in default_keys:
        Player.key[x] = 0
    if len(Character.key['classes']):
        Class = Character.key['classes'].keys()[0]
    else:
        Class = None
    if Class:
        Playerlib.set('speed', dnds.Classes[Class]['speed'])
        es.setplayerprop(userid, 'CCSPlayer.m_iAccount', int(es.getplayerprop(userid, 'CCSPlayer.m_iAccount'))+(500*dnds.statMod(userid, 'Charisma')))
        Player.key['healing surges'] = dnds.Classes[Class]['healing surges']+dnds.statMod(userid, 'Constitution')
        Health(userid, dnds.Classes[Class]['health']+Character.key['abilities']['Constitution']*10)
        es.setplayerprop(userid, 'CCSPlayer.m_ArmorValue', dnds.Classes[Class]['armor'])
        if dnds.Classes[Class]['helmet']:
            es.setplayerprop(userid, 'CCSPlayer.m_bHasHelmet', 1)
def player_hurt(ev):
    userid = int(ev['userid'])
    attacker = int(ev['attacker'])
    damage = int(ev['dmg_health'])
    PlayerHurt(userid, attacker, damage, ev['weapon'], dnds.getPlayer(userid)['Character'].key['classes'].keys(), dnds.getPlayer(userid)['Character'])
    if attacker:
        PlayerHit(attacker, userid, damage, ev['weapon'], dnds.getPlayer(attacker)['Character'].key['classes'].keys(), dnds.getPlayer(attacker)['Character'])
#End Local Events
#Global Events
#End Global Events
#End Events
#Command Methods
#Handels the count down for the wizard's spell cool downs
def spellCoolDown(userid, duration):
    if duration >= .5:
        duration -= .5
        dnds.getPlayer(userid)['Player'].key['spell cool down'] = duration
        dnds.getPlayer(userid)['Player'].Delayed(.5, spellCoolDown, (userid, duration))
    else:
        dnds.getPlayer(userid)['Player'].key['spell cool down'] = 0
#Cleric's glow command
def glowcmd():
    userid = int(es.getcmduserid())
    dnds.report('%s ran the glowcmd in chat/console'%es.getplayername(userid))
    if not dnds.getPlayer(userid)['Player'].key['glow used']:
        if 'Cleric' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            level = dnds.getPlayer(userid)['Character'].key['classes']['Cleric']['level']
            if level >= 5:
                dnds.getPlayer(userid)['Player'].key['glow used'] = 1
                dnds.getPlayer(userid)['Player'].Delayed(15, glowSelf, userid)
                flist, olist = dnds.getPlayer(userid)['Player'].NearList(480)
                team = es.getplayerteam(userid)
                for id in olist:
                    dnds.getPlayer(id)['Player'].Damage(random.randint(14,33),userid)
                for id in flist:
                    dnds.getPlayer(id)['Player'].key['glowing'] = 1
                    dnds.getPlayer(id)['Player'].Delayed(6, glowAlly, id)
            else:
                es.tell(userid, '#multi', dnds.text('glowcmd 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('glowcmd 2',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
    else:
        es.tell(userid, '#multi', dnds.text('glowcmd 3',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
def glowSelf(userid):
    dnds.getPlayer(userid)['Player'].key['glow used'] = 0
    es.tell(userid, '#multi', dnds.text('glowSelf 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
def glowAlly(id):
    dnds.getPlayer(id)['Player'].key['glowing'] = 0
#Cleric's word command
def wordcmd():
    #es.msg('wordcmd')
    userid = int(es.getcmduserid())
    dnds.report('%s ran the wordcmd in chat/console'%es.getplayername(userid))
    if not dnds.getPlayer(userid)['Player'].key['word used']:
        if 'Cleric' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            level = dnds.getPlayer(userid)['Character'].key['classes']['Cleric']['level']
        elif 'Warlord' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            level = dnds.getPlayer(userid)['Character'].key['classes']['Warlord']['level']
            if level >= 1:
                es.ServerVar('_dnds_temp').set(0)
                es.server.queuecmd('est_getviewplayer %s _dnds_temp'%userid)
                gamethread.delayed(.1, wordRun, (userid, level))
            else:
                es.tell(userid, '#multi', dnds.text('wordcmd 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('wordcmd 2',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
    else:
        es.tell(userid, '#multi', dnds.text('wordcmd 3',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
def wordRun(userid, level):
    target = int(es.ServerVar('_dnds_temp'))
    #es.msg('Target = %s'%target)
    #es.msg('Word Run')
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 200+(level*10):
            dnds.getPlayer(userid)['Player'].key['word used'] = 1
            gamethread.delayed(15, wordWipe, (userid))
            HealingSurge(target)
            if level < 6:
                amount = random.randint(2, 8)
            elif level < 11:
                amount = random.randint(4, 6)
            elif level < 16:
                amount = random.randint(6, 24)
            elif level < 21:
                amount = random.randint(8, 30)
            elif level < 26:
                amount = random.randint(10, 36)
            else:
                amount = random.randint(12, 44)
            Heal(target, amount)
            es.tell(userid, '#multi', dnds.text('wordRun 1',{'name':es.getplayername(target),'amount':amount},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('wordRun 2',{'name':es.getplayername(target)},dnds.getPlayer(userid)['playerlib'].get('lang')))
def wordWipe(userid):
    dnds.getPlayer(userid)['Player'].key['word used'] = 0
    es.tell(userid, '#multi', dnds.text('wordWipe 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Begin +wind and -wind
def WindOn():
    userid = int(es.getcmduserid())
    if dnds.getPlayer(userid)['Player'].key['maxhealth'] != int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth')):
        if not dnds.getPlayer(userid)['Player'].key['wind used']:
            if dnds.getPlayer(userid)['Player'].key['healing surges']:
                dnds.getPlayer(userid)['Player'].key['wind on'] = 1
                dnds.getPlayer(userid)['Player'].Delayed(1, WindLoop, (userid, 1))
                dnds.getPlayer(userid)['Player'].Freeze()
                es.tell(userid, '#multi', dnds.text('WindOn 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('WindOn 2',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('WindOn 3',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
    else:
        es.tell(userid, '#multi', dnds.text('WindOn 4',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
def WindOff():
    userid = int(es.getcmduserid())
    dnds.getPlayer(userid)['Player'].Unfreeze()
    dnds.getPlayer(userid)['Player'].key['wind on'] = 0
def WindLoop(userid, count):
    if count < 3 and dnds.getPlayer(userid)['Player'].key['wind on']:
        dnds.getPlayer(userid)['Player'].Delayed(1, WindLoop, (userid, count+1))
    else:
        WindRun(userid)
def WindRun(userid):
    dnds.getPlayer(userid)['Player'].key['wind used'] = 1
    HealingSurge(userid)
    dnds.getPlayer(userid)['Player'].Unfreeze()
    dnds.getPlayer(userid)['Player'].key['wind on'] = 0
    dnds.getPlayer(userid)['Player'].Delayed(20, WindWipe, userid)
def WindWipe(userid):
    dnds.getPlayer(userid)['Player'].key['wind used'] = 0
    if dnds.getPlayer(userid)['Player'].key['healing surges']:
        es.tell(userid, '#multi', dnds.text('WindWipe 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Helps me break down events and pass in key info about users
def PlayerHurt(userid, attacker, damage, weapon, Classes, Character):
    Dead = dnds.getPlayer(userid)['playerlib'].get('isdead')
    if 'Cleric' in Classes:
        level = Character.key['classes']['Cleric']['level']
        if level >= 2:
           Heal(userid, damage/10) 
    dexmod = dnds.statMod(userid, 'Dexterity')*4
    intmod = dnds.statMod(userid, 'Intelligence')*4
    if not Dead:
        chance = random.randint(1, 100)
        if dexmod > intmod:
            if dexmod >= chance:
                Heal(userid, damage)
                es.tell(userid, '#multi', dnds.text('PlayerHurt 1',{'damage':damage,'stat':'Dexterity'},dnds.getPlayer(userid).get('lang')))
        else:
            if intmod >= chance:
                Heal(userid, damage)
                es.tell(userid, '#multi', dnds.text('PlayerHurt 1',{'damage':damage,'stat':'Intelligence'},dnds.getPlayer(userid).get('lang')))
def PlayerHit(userid, victim, damage, weapon, Classes, Character):
    DamageBuff = 1
    if 'Cleric' in Classes:
        level = Character.key['classes']['Cleric']['level']
        if level >= 3:
            if not random.randrange(5):
                dnds.getPlayer(victim)['Player'].Damage(damage*.4,userid)
                if not random.randrange(3):
                    dnds.getPlayer(victim)['playerlib'].set('burn')
                    gamethread.delayed(3, dnds.getPlayer(victim)['playerlib'].set, "extinguish")
    if dnds.getPlayer(userid)['Player'].key['glowing']:
        dnds.getPlayer(victim)['Player'].Damage(damage*.1,userid)
    if DamageBuff:
        dnds.getPlayer(victim)['Player'].Damage(damage*(.05*dnds.statMod(userid, 'Strength')),userid)
#Following two handel health
def HealingSurge(userid, user=None):
    if not user:
        hs = dnds.getPlayer(userid)['Player'].key['healing surges']
    else:
        hs = dnds.getPlayer(user)['Player'].key['healing surges']
    if hs:
        if dnds.getPlayer(userid)['Player'].key['maxhealth'] != int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth')):
            Character = dnds.getPlayer(userid)['Character']
            Class = Character.key['classes'].keys()[0]
            Surge = ((dnds.getPlayer(userid)['Player'].key['maxhealth'])/2)/2
            Heal(userid, Surge)
            if not user:
                dnds.getPlayer(userid)['Player'].key['healing surges'] -= 1
            else:
                dnds.getPlayer(user)['Player'].key['healing surges'] -= 1
            es.tell(userid, '#multi', dnds.text('HealingSurge 1',{'surge':Surge,'remaining':dnds.getPlayer(userid)['Player'].key['healing surges']},dnds.getPlayer(userid)['playerlib'].get('lang')))
def Health(userid, amount, value='set'):
    if value == 'set':
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', amount)
        dnds.getPlayer(userid)['Player'].key['maxhealth'] = amount
    elif value == 'add':
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth'))+amount)
        dnds.getPlayer(userid)['Player'].key['maxhealth'] += amount
def Heal(userid, amount):
    if not dnds.getPlayer(userid)['playerlib'].get('isdead'):
        Health = int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth'))
        MaxHealth = int(dnds.getPlayer(userid)['Player'].key['maxhealth'])
        if (Health+amount) <= MaxHealth:
            es.setplayerprop(userid, 'CBasePlayer.m_iHealth', Health+amount)
        else:
            es.setplayerprop(userid, 'CBasePlayer.m_iHealth', MaxHealth)
#End Command Methods
#Begin Load Methods
def load():
    es.dbgmsg(0, '[Dungeons and Dragons] - CSTRIKE Begin Load')
    for x in dnds.Class_List:
        for i in range(1, 5):
            dnds.Classes[x]['info'].append('cstrike %s %s'%(x, i))
            if x != 'Ranger':
                dnds.Classes[x]['powers1'].append('cstrike %s Powers1 %s'%(x, i))
            elif x == 'Ranger':
                dnds.Classes[x]['powers1'].append('cstrike %s Archer Powers1 %s'%(x, i))
                dnds.Classes[x]['powers1'].append('cstrike %s Two Weapon Powers1 %s'%(x, i))
        if x == 'Rogue':
            dnds.Classes[x]['info'].append('cstrike %s 5'%(x))
        for y in ClassSet[x]:
            dnds.Classes[x][y] = ClassSet[x][y]
    for a in ['Strength','Charisma']:
        dnds.Abilities[a]['info'].append('cstrike %s 1'%a)
    if not es.exists('clientcommand','+wind'):
        es.regclientcmd('+wind','dnds/games/pvkiidnds/WindOn')
    if not es.exists('clientcommand','-wind'):
        es.regclientcmd('-wind','dnds/games/pvkiidnds/WindOff')
    for x in Commands:
        if not es.exists('clientcommand', x):
            es.regclientcmd(x, 'dnds/games/pvkiidnds/%scmd'%x)
        if not es.exists('saycommand', x):
            es.regsaycmd(x, 'dnds/games/pvkiidnds/%scmd'%x)
    es.dbgmsg(0, '[Dungeons and Dragons] - CSTRIKE End Load')
Commands = ['word','glow','glowing']
default_keys = ['spell cool down','wind used','wind on']
Pistols = ['glock','usp','p228','deagle','fiveseven','elite']
ShotGuns = ['m3','xm1014']
SMGs = ['mac10','tmp','ump45','mp5navy','p90']
Rifles = ['gali','famas','m4a1','ak47','sg552','aug']
Snipers = ['scout','awp','sg550','g3sg1']
Grenades = ['hegrenade','flashbang','smokegrenade']
Weapons = ['glock','usp','p228','deagle','fiveseven','elite','m3','xm1014','mac10','tmp','ump45','mp5navy','p90','scout','awp','sg550','g3sg1','hegrenade','flashbang','smokegrenade','m249','knife']
ClassSet = {'Cleric':   {'health':120,
                        'armor':90,
                        'helmet':0,
                        'weapons': ['knife','m3','famas','galil']+Pistols,
                        'healing surges':7,
                        'speed':1.0},
            'Fighter':  {'health':150,
                        'armor':100,
                        'helmet':1,
                        'weapons':['knife','scout','m249']+Pistols+Rifles+SMGs+ShotGuns,
                        'healing surges':9,
                        'speed':1.0},
            'Paladin':  {'health':150,
                        'armor':125,
                        'helmet':1,
                        'weapons':['knife','scout','m249']+Pistols+Rifles+SMGs+ShotGuns,
                        'healing surges':10,
                        'speed':1.0},
            'Ranger':   {'health':120,
                        'armor':90,
                        'helmet':0,
                        'weapons':['knife','scout']+Pistols+SMGs+Rifles,
                        'healing surges':6,
                        'speed':1.0},
            'Rogue':    {'health':120,
                        'armor':90,
                        'helmet':0,
                        'weapons':['knife','scout']+Pistols+SMGs,
                        'healing surges':6,
                        'speed':1.0},
            'Warlock':  {'health':120,
                        'armor':60,
                        'helmet':0,
                        'weapons':['knife','ump45']+Pistols,
                        'healing surges':6,
                        'speed':1.0},
            'Warlord':  {'health':120,
                        'armor':90,
                        'helmet':0,
                        'weapons':['knife','famas','galil']+Pistols+SMGs+ShotGuns,
                        'healing surges':7,
                        'speed':1.0},
            'Wizard':   {'health':100,
                        'armor':25,
                        'helmet':0,
                        'weapons':['knife']+Pistols,
                        'healing surges':6,
                        'speed':1.0}}
#End Load Methods
#Our Client Command Filter
def _cc_filter(userid, args):
    if args[0].lower() == 'buy' and len(args) > 1:
        weapon = args[1].lower().replace('weapon_','')
        Classes = dnds.getPlayer(userid)['Character'].key['classes'].keys()
        wplist = []
        for c in Classes:
            wplist += dnds.Classes[c]['weapons']
        if weapon not in wplist:
            return Flase
    return True
es.addons.registerClientCommandFilter(_cc_filter)